<?php
include ('pear/archive_zip.php'); 
include ('pear/Tar.php'); 

// Name of the archive
$name = (!empty($_GET['name'])) ? $name = $_GET['name'] : $name = 'script';

// Just some protection
$name = str_replace("\\\\", '', $name);
$name = str_replace("\\", '', $name);
$name = str_replace('/', '', $name);

// Type specified?
$type = (!empty($_GET['type'])) ? $type = $_GET['type'] : $type = 'zip';
if ($type != 'zip' AND $type != 'tar') { $type = 'zip'; }

// Add this script to the list
$list = array('download.php');

// Create the archive
$data = create_archive ($name, $list, $type);

if ($type == 'zip') {
	$mimetype = 'application/zip';
	$name .= '.zip';
} else {
	$mimetype = 'application/x-tar-gz';
	$name .= '.tar.gz';
}

// Send file
force_download ($data, $name, $mimetype);
die();

function create_archive ($name, $list, $type='zip') {
	// Get temporary directory
	if (!empty($_ENV['TMP'])) {
		$tempdir = $_ENV['TMP'];
	} elseif (!empty($_ENV['TMPDIR'])) {
		$tempdir = $_ENV['TMPDIR'];
	} elseif (!empty($_ENV['TEMP'])) {
		$tempdir = $_ENV['TEMP'];
	} else {
		$tempdir = dirname(tempnam('', 'na'));
	}

	if (empty($tempdir)) { die ('No temporary directory'); }

	// Make sure trailing slash is there
	$tempdir = rtrim($tempdir, '/');
	$tempdir .= '/';

	// Make sure temporary directory is writable
	if (is_writable($tempdir) == false) {
		die ('Temporary directory isn\'t writable');
	}

	// Create temp name	for our own directory
	$dir = tempnam($tempdir, 'temp');

	// Make sure another file or directory doesn't already exist with this name
	@unlink($dir);
	@rmdir($dir);

	// Create directory
	mkdir($dir);
	$dir .= '/';

	// Copy files & directories so relative paths still work
	foreach ($list as $item) {
		if (is_file($item)) {
			// Copy file
			copy ($item, $dir . $item);
		} elseif (is_dir ($item)) {
			// Copy directory
			move_directory ($item, $dir . $item, true);
		} else {
			// Invalid file, just ignore
			continue;
		}
	}

	// Change current working directory, so that the zip file gets created in the temp dir
	chdir($dir);

	// Create zip or tar.gz file
	if ($type == 'zip') {
		$name .= '.zip';
		$zipfile = New Archive_Zip($name);
		$zipfile->create($list);
	} else {
		$name .= '.tar.gz';
		$tarfile = New Archive_Tar($name, 'gz');
		$tarfile->create($list);
	}

	// Get file data
	$data = implode('', file($name));
	return $data;
}

function move_directory($source, $dest, $copy=false) {
	// Standardize paths
	$source = str_replace('\\\\', '/', $source);
	$source = str_replace('\\', '/', $source);

	$dest = str_replace('\\\\', '/', $dest);
	$dest = str_replace('\\', '/', $dest);

	// Remove trailing slashes
	$source = rtrim($source, '/');
	$dest = rtrim($dest, '/');

	// Add trailing slashes
	$source .= '/';
	$dest .= '/';

	// Source doesn't exist?
	if (file_exists($source) == false) { return false; }

	// Try to create destination
	@mkdir($dest);

	// Destination doesn't exist?
	if (file_exists($dest) == false) { return false; }

	// Copy all files
	$d = dir($source);

	while (false !== ($entry = $d->read())) {
		if ($entry == '.' OR $entry == '..') continue;
		$file = $d->path . $entry;

		// Is a sub dir?
		if (is_dir($file)) {
			// Try to create sub dir
			$subdir = $dest . $entry . '/';
			$result = @mkdir($subdir);
			if ($result == false) { continue; }

			// Move files in sub directory
			move_directory($file, $subdir, $copy);
			continue;
		}

		// Copy file
		copy($file, $dest . $entry);

		// Remove old file?
		if ($copy == false) {
			// Moving the directory, so remove original
			@unlink($file);
		}
	}	

	if ($copy == false) {
		@rmdir($source);
	}

	return true;
}

function force_download ($data, $name, $mimetype='', $filesize=false) {
    // File size not set?
    if ($filesize == false OR !is_numeric($filesize)) {
        $filesize = strlen($data);
    }

    // Mimetype not set?
    if (empty($mimetype)) {
        $mimetype = 'application/octet-stream';
    }

    // Make sure there's not anything else left
    ob_clean_all();

    // Start sending headers
    header("Pragma: public"); // required
    header("Expires: 0");
    header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
    header("Cache-Control: private",false); // required for certain browsers
    header("Content-Transfer-Encoding: binary");
    header("Content-Type: " . $mimetype);
    header("Content-Length: " . $filesize);
    header("Content-Disposition: attachment; filename=\"" . $name . "\";" );

    // Send data
    echo $data;
    die();
}

function ob_clean_all () {
    $ob_active = ob_get_length () !== false;
    while($ob_active) {
        ob_end_clean();
        $ob_active = ob_get_length () !== false;
    }

    return true;
}

?>